# aem-backup-cli
A Developer CLI utility to backup local AEM instances, and save lives!

<p align="center">
  <br>
  <img src="screenshot.svg">
  <br>
</p>

## Usage

1. make sure you have node 8 (or later) installed 
2. install the `aem-backup-cli` CLI `npm install -g aem-backup-cli`
3. `cd` into your AEM instance directory (where `crx-quickstart` folder is)
4. run `aemb`

> **Your AEM instance must be completely SHUTDOWN before performing a backup**
> 
> If you break it, it's no my fault ;)

Voila! you are now in the interactive CLI. can now enjoy all available commands, try `help` to see all commands. or `help [command]` to get help on a specific command.

```bash

aemb$ help

  Commands:

    help [command...]              Provides help for a given command.
    exit                           Exits application.
    backup [options] [backupName]  Archive crx-quickstart in current directory and move archive to crx-quickstart.backups folder in current directory
    list                           List all available backups
    delete [options]               Delete a backup from available backups
    restore [options]              Restore a backup from a list of available backups

```

## Why?
I break my AEM local instances more times that I can count, sometimes beyond repair. This usually means I have to start fresh and install content packages, update packages, my project code and do any other required manual configuration for my project... if you cant tell, this is tedious and I've decided: NO MORE!

## How does it work?
This tool does an **offline** **filesystem** backup of your whole AEM instance, basically the `crx-quickstart` folder.

> Since this tool does a **filesystem** backup, your AEM instance must be **shutdown** while performing a backup/restore.

### Yeah but how exactly?
using the [`node-tar`](https://github.com/npm/node-tar) module, this CI [tar](https://en.wikipedia.org/wiki/Tar_(computing))'s the `crx-quickstart` folder and saves the resulting tar into a sibling folder called `crx-quickstart.backups`.

### Interacting with the `crx-quickstart.backups` folder directly
You *can* do the following things and the CLI will still work

  -  delete the entire `crx-quickstart.backups` folder 
  -  delete one or more `.tar` backups in the `crx-quickstart.backups` folder 
  -  Add a `.tar` backup in the `crx-quickstart.backups` folder (as long as it's just a tar, not a compressed tar)**\***. 
  
  > **\***I cant guarantee that adding any tar of `crx-quickstart` to `crx-quickstart.backups` will work, however, any backup tar generated by this tool, *should* work. eg, your friend makes a backup of his instance, then sends you the tar, that should work just fine.

## caveats
1. The CLI tar's the whole `crx-quickstart` directory, that directory is usually above `2.5GB`(clean AEM instance). Thus, the backup and restore speeds depends on your computer specs.
2. To enhance backup performance, the CLI tar's but does NOT compress! This ensures fast backups, however, it will keep the backup size the same. Make sure you delete unwanted backups.




 
